#define PREF_ETH   "eth"
#define PREF_EM    "em"

static char *dev_file = "/proc/self/net/dev";

/*
 * get_first_ethernet - return the name of the first ethernet-style
 * interface on this system.
 */
char *
get_first_ethernet()
{
  FILE *f;
  char buf[255], *dv, *smc;
  char pci[16];

  memset(pci, 0, sizeof(pci));
  if ((f = fopen(dev_file, "r")) != NULL)
  {
    // go through network dev file
    while (fgets (buf, sizeof(buf), f) != NULL)
    {
      // the line describes interface
      if ((smc = strchr(buf, ':')) != NULL)
      {
        // trim white characters
        for (dv=buf, *smc=0; *dv <= ' '; dv++) ;
        // is "eth" (originial ethernet name) or "em" (ethernet on board)
        if (!strncmp(dv, PREF_ETH, strlen(PREF_ETH)) ||
            !strncmp(dv, PREF_EM, strlen(PREF_EM)))
        {
          return strdup(dv);
        }
        // remember the first pci NIC-card
        if (strlen(pci) == 0 && dv[0] == 'p' && isdigit(dv[1]))
        {
          strcpy(pci, dv);
        }
      }
    }
    fclose(f);
  }
  // return pci NIC-card or nil if no if name
  return strlen(pci) > 0 ? strdup(pci) : 0L;
}

